import java.lang.*;
import java.util.*;
import java.awt.geom.*;
import java.awt.*;
import java.io.*;

import edu.umd.cs.jazz.*;
import edu.umd.cs.jazz.util.*;
import edu.umd.cs.jazz.event.*;
import edu.umd.cs.jazz.component.*;
import javax.swing.*;
import com.stevesoft.pat.*;

class RunningQuery {
    Regex _regex = null;
    int _dgnodeid = -1;
    FileVector _input_vector = null;
    FileVector _output_vector = null;
    boolean _processing_complete = false;
    String _output_file_name = null;
    int _processed_so_far = 0;
    DataGraph _datagraph = null;
    static private int BATCH_SIZE = 100;

    RunningQuery(DataGraph datagraph_, String output_file_name_, Regex regular_expn_, int dgnode_id_, FileVector offsets_) {
	_datagraph = datagraph_;
	_output_file_name = output_file_name_;
	_regex = regular_expn_;
	_dgnodeid = dgnode_id_;
	_input_vector = offsets_;
	_output_vector = new FileVector(output_file_name_, 0);
    }

    protected void finalize() throws Throwable {
	File temp_file = new File(_output_file_name);
	temp_file.delete();
    }

    public boolean processingComplete() {
	return _processing_complete;
    }

    public FileVector getPartialResult() {
	return _output_vector;
    }

    public int getNode() {
	return _dgnodeid;
    }

    public void runQuery() {
	if(_processed_so_far == _input_vector.size()) {
	    _processing_complete = true;
	    return;
	}
	int count = 0;
	while(!_processing_complete && count < BATCH_SIZE) {
	    Long curr_offset = (Long)(_input_vector.elementAt(_processed_so_far));
	    DataNode curr_node = (DataNode)(_datagraph.getDataNodeNoChildren(curr_offset.longValue()));
	    String curr_data = curr_node.getData();
	    _regex.search(curr_data);
	    if(_regex.didMatch()) {
		if(MyFrame._debug_mode > 8) {
		    System.out.println("found match at "+_processed_so_far);
		}
		_output_vector.addElementRandom(curr_offset);
	    }
	    _processed_so_far++;
	    if(_processed_so_far == _input_vector.size()) {
		_processing_complete = true;
	    }
	    count++;
	}	
	System.out.println("Processed "+_processed_so_far+"/"+_input_vector.size());
    }
}
